import { computed as u, createElementBlock as s, openBlock as l, createCommentVNode as a } from "vue";
import { W as f, P as y } from "./index-BNW_2-Fm.js";
const c = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], g = ["d", "fill", "stroke", "stroke-width"], x = ["points", "fill", "stroke", "stroke-width"], w = {
  __name: "Shape",
  props: {
    color: String,
    isSelected: {
      type: Boolean,
      default: !1
    },
    limit: {
      type: Number,
      default: 3
    },
    plot: Object,
    radius: Number,
    shape: String,
    stroke: String,
    strokeWidth: Number,
    zoom: {
      type: Number,
      default: 1.3
    }
  },
  emits: ["mouseover", "mouseout", "click"],
  setup(e, { emit: k }) {
    const o = e, n = k;
    function v(m) {
      return {
        circle: {
          points: 1,
          rotation: 0
        },
        line: {
          points: 2,
          rotation: 0
        },
        triangle: {
          points: 3,
          rotation: 0.52
        },
        square: {
          points: 4,
          rotation: 0.783
        },
        diamond: {
          points: 4,
          rotation: 0
        },
        pentagon: {
          points: 5,
          rotation: 0.95
        },
        hexagon: {
          points: 6,
          rotation: 0
        }
      }[m];
    }
    const r = u(() => v(o.shape)), d = u(() => o.shape !== "star" ? null : f({
      plot: { x: o.plot.x, y: o.plot.y },
      radius: o.radius * (o.isSelected ? o.zoom : 1)
    })), p = u(() => y({
      plot: { x: o.plot.x, y: o.plot.y },
      radius: o.radius * (o.isSelected ? o.zoom : 1),
      sides: r.value.points,
      rotation: r.value.rotation
    }).path);
    return (m, t) => (l(), s("g", null, [
      r.value && r.value.points === 1 ? (l(), s("circle", {
        key: 0,
        cx: e.plot.x,
        cy: e.plot.y,
        r: o.radius * (o.isSelected ? o.zoom : 1),
        fill: e.color,
        stroke: e.stroke,
        "stroke-width": e.strokeWidth,
        onMouseover: t[0] || (t[0] = (i) => n("mouseover")),
        onMouseout: t[1] || (t[1] = (i) => n("mouseout")),
        onClick: t[2] || (t[2] = (i) => n("click"))
      }, null, 40, c)) : a("", !0),
      r.value && r.value.points >= e.limit ? (l(), s("path", {
        key: 1,
        d: p.value,
        fill: e.color,
        stroke: e.stroke,
        "stroke-width": e.strokeWidth,
        onMouseover: t[3] || (t[3] = (i) => n("mouseover")),
        onMouseout: t[4] || (t[4] = (i) => n("mouseout")),
        onClick: t[5] || (t[5] = (i) => n("click"))
      }, null, 40, g)) : a("", !0),
      d.value ? (l(), s("polygon", {
        key: 2,
        points: d.value,
        fill: e.color,
        stroke: e.stroke,
        "stroke-width": e.strokeWidth,
        onMouseover: t[6] || (t[6] = (i) => n("mouseover")),
        onMouseout: t[7] || (t[7] = (i) => n("mouseout")),
        onClick: t[8] || (t[8] = (i) => n("click"))
      }, null, 40, x)) : a("", !0)
    ]));
  }
};
export {
  w as _
};
