import { useSlots as nt, onMounted as Le, computed as k, ref as f, watch as st, onBeforeUnmount as rt, createElementBlock as C, openBlock as p, unref as g, normalizeStyle as D, normalizeClass as Re, createBlock as E, createCommentVNode as P, createElementVNode as z, createVNode as De, createSlots as ut, withCtx as T, renderSlot as x, normalizeProps as X, guardReactiveProps as j, Fragment as Me, renderList as Ve, toDisplayString as Y, mergeProps as it, createTextVNode as Ue, nextTick as ct } from "vue";
import { u as dt, c as Be, t as vt, p as O, a as ht, b as ft, o as pt, e as gt, d as ae, i as ne, f as K, X as yt, l as He, G as We, x as Ee, q as mt, r as bt, y as wt } from "./index-BNW_2-Fm.js";
import { _ as kt } from "./Title-BFDV9wVq.js";
import { u as Ct, U as $t } from "./usePrinter-BjRHYhy_.js";
import { _ as xt } from "./Tooltip-D00t4gXc.js";
import { L as Tt } from "./Legend-6aaarnxX.js";
import Ot from "./vue-ui-skeleton-Cmgr79Qn.js";
import { D as _t } from "./DataTable-DeBTilxd.js";
import St from "./vue-ui-accordion-I-T_dCU6.js";
import { t as Nt, u as Pt } from "./useResponsive-CoxXLe23.js";
import { u as Ge } from "./useNestedProp-BJPdFivN.js";
import { _ as zt } from "./PackageVersion-C8w0hsiM.js";
import { P as At } from "./PenAndPaper-DuGIDJqu.js";
import { u as Ft } from "./useUserOptionState-BIvW1Kz7.js";
import { _ as It } from "./_plugin-vue_export-helper-CHgC5LLL.js";
function qe(a, u) {
  const s = a.length;
  if (s === 0)
    throw new Error(`Max aspect ratio cannot be computed: ${a} is an empty array`);
  {
    let i = 1 / 0, n = -1 / 0, d = 0;
    for (let v = 0; v < s; v += 1) {
      const h = a[v].normalizedValue;
      h < i && (i = h), h > n && (n = h), d += h;
    }
    return Math.max(
      u ** 2 * n / d ** 2,
      d ** 2 / (u ** 2 * i)
    );
  }
}
function Xe(a) {
  const { xOffset: u, yOffset: s, width: i, height: n } = a;
  return {
    x0: u,
    y0: s,
    x1: u + i,
    y1: s + n
  };
}
function Lt(a, u, s) {
  if (a.length === 0)
    return !0;
  {
    const i = a.concat(u), n = qe(
      a,
      s
    ), d = qe(i, s);
    return n >= d;
  }
}
function Rt(a) {
  const u = [], s = a.length;
  for (let i = 0; i < s; i += 1) {
    const n = a[i], d = n.length;
    for (let c = 0; c < d; c += 1)
      u.push(n[c]);
  }
  return u;
}
function Dt(a, u) {
  const s = {
    ...u,
    children: a
  };
  return Ye(s);
}
function Mt(a) {
  return (a.x1 - a.x0) * (a.y1 - a.y0);
}
function je(a, u) {
  const { width: s, height: i, xOffset: n, yOffset: d } = de(u), c = a.length, v = a.map((b) => b.normalizedValue || 0).reduce((b, y) => b + y, 0), h = v / i, S = v / s;
  let _ = n, N = d;
  const w = [];
  if (s >= i) {
    for (let b = 0; b < c; b += 1) {
      const y = a[b], $ = N + y.normalizedValue / h, M = {
        x0: _,
        y0: N,
        x1: _ + h,
        y1: $
      }, A = Object.assign({}, y, M);
      N = $, w.push(A);
    }
    return w;
  } else {
    for (let b = 0; b < c; b += 1) {
      const y = a[b], $ = _ + y.normalizedValue / S, M = {
        x0: _,
        y0: N,
        x1: $,
        y1: N + S
      }, A = Object.assign({}, y, M);
      _ = $, w.push(A);
    }
    return w;
  }
}
function Vt(a) {
  const u = de(a), s = u.width, i = u.height;
  return Math.min(s, i);
}
function Ut(a, u) {
  const s = a.length, i = a.map((h) => h.value ?? 0).reduce((h, S) => h + S, 0), n = u / i, d = [];
  let c, v;
  for (let h = 0; h < s; h += 1)
    v = a[h], c = Object.assign({}, v, {
      normalizedValue: v.value * (n || 0)
    }), d.push(c);
  return d;
}
function de(a) {
  const { x0: u, y0: s, x1: i, y1: n } = a;
  return {
    xOffset: u,
    yOffset: s,
    width: i - u,
    height: n - s
  };
}
function Bt(a, u, s, i) {
  let n = a, d = u, c = s, v = i;
  for (; ; ) {
    const h = n.length;
    if (h === 0) {
      const w = je(d, c);
      return v.concat(w);
    }
    const S = Vt(c), _ = n[0], N = n.slice(1, h);
    if (Lt(d, _, S)) {
      const w = d.concat(_);
      n = N, d = w, c = c, v = v;
    } else {
      const w = d.length;
      let b = 0;
      for (let A = 0; A < w; A += 1)
        b += d[A].normalizedValue;
      const y = Ht(c, b), $ = je(d, c), M = v.concat($);
      n = n, d = [], c = y, v = M;
    }
  }
}
function Ye(a) {
  if (typeof a.children > "u" || !a.children.length)
    return [a];
  {
    const u = Ut(
      a.children,
      Mt(a)
    ), s = Bt(u, [], a, []), i = s.length, n = [];
    for (let c = 0; c < i; c += 1)
      n.push(Ye(s[c]));
    return Rt(n);
  }
}
function Ht(a, u) {
  const { width: s, height: i, xOffset: n, yOffset: d } = de(a);
  if (s >= i) {
    const c = u / i, v = s - c, h = {
      xOffset: n + c,
      yOffset: d,
      width: v,
      height: i
    };
    return Xe(h);
  } else {
    const c = u / s, v = i - c, h = {
      xOffset: n,
      yOffset: d + c,
      width: s,
      height: v
    };
    return Xe(h);
  }
}
const Wt = ["id"], Et = ["xmlns", "viewBox"], Gt = { key: 0 }, qt = ["id"], Xt = ["stop-color"], jt = ["stop-color"], Yt = ["x", "y", "height", "width", "fill", "rx", "stroke", "stroke-width", "onClick", "onMouseenter"], Zt = ["x", "y", "height", "width"], Jt = {
  style: { width: "100%", height: "100%" },
  class: "vue-ui-treemap-cell"
}, Kt = {
  key: 5,
  class: "vue-data-ui-watermark"
}, Qt = ["onClick"], eo = { key: 0 }, to = { key: 1 }, oo = ["innerHTML"], lo = {
  __name: "vue-ui-treemap",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(a, { expose: u, emit: s }) {
    const { vue_ui_treemap: i } = dt(), n = a, d = s, c = nt();
    Le(() => {
      c["chart-background"] && console.warn("VueUiTreemap does not support the #chart-background slot.");
    });
    const v = k(() => !!n.dataset && n.dataset.length), h = k(() => /^((?!chrome|android).)*safari/i.test(navigator.userAgent)), S = f(Be()), _ = f(!1), N = f(""), w = f(!1), b = f(0), y = f([]), $ = f(null), M = f(null), A = f(null), ve = f(null), he = f(null), fe = f(0), pe = f(0), ge = f(0), e = k({
      get: () => be(),
      set: (t) => t
    }), { userOptionsVisible: se, setUserOptionsVisibility: ye, keepUserOptionState: me } = Ft({ config: e.value });
    function be() {
      const t = Ge({
        userConfig: n.config,
        defaultConfig: i
      });
      return t.theme ? {
        ...Ge({
          userConfig: ht.vue_ui_treemap[t.theme] || n.config,
          defaultConfig: t
        }),
        customPalette: vt[t.theme] || O
      } : t;
    }
    st(() => n.config, (t) => {
      e.value = be(), se.value = !e.value.userOptions.showOnChartHover, fe.value += 1, pe.value += 1, ge.value += 1, F.value.showTable = e.value.table.show, F.value.showTooltip = e.value.style.chart.tooltip.show;
    }, { deep: !0 });
    const { isPrinting: we, isImaging: ke, generatePdf: Ce, generateImage: $e } = Ct({
      elementId: `treemap_${S.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-treemap"
    }), Ze = k(() => e.value.userOptions.show && !e.value.style.chart.title.text), Q = k(() => ft(e.value.customPalette)), F = f({
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), V = f({
      height: e.value.style.chart.height,
      width: e.value.style.chart.width
    }), B = k(() => ({
      bottom: V.value.height - e.value.style.chart.padding.bottom,
      height: V.value.height - e.value.style.chart.padding.top - e.value.style.chart.padding.bottom,
      left: e.value.style.chart.padding.left,
      right: V.value.width - e.value.style.chart.padding.right,
      top: e.value.style.chart.padding.top,
      vbHeight: V.value.height,
      vbWidth: V.value.width,
      width: V.value.width - e.value.style.chart.padding.left - e.value.style.chart.padding.right
    }));
    function xe(t) {
      t.forEach((l, o) => {
        l.id = Be(), l.color = ae(l.color) || Q.value[o] || O[o] || O[o % O.length], l.children && (l.children.forEach((r) => {
          r.parentId = l.id, r.color = l.color;
        }), xe(l.children));
      });
    }
    const H = f(n.dataset), ee = f(null);
    Le(() => {
      Je();
    });
    function Je() {
      if (pt(n.dataset) && gt({
        componentName: "VueUiTreemap",
        type: "dataset"
      }), xe(H.value), e.value.responsive) {
        const t = Nt(() => {
          const { width: l, height: o } = Pt({
            chart: $.value,
            title: e.value.style.chart.title.text ? M.value : null,
            legend: e.value.style.chart.legend.show ? A.value : null,
            source: ve.value,
            noTitle: he.value
          });
          requestAnimationFrame(() => {
            V.value.width = l, V.value.height = o;
          });
        });
        ee.value = new ResizeObserver(t), ee.value.observe($.value.parentNode);
      }
    }
    rt(() => {
      ee.value && ee.value.disconnect();
    });
    const re = f(H.value), Z = k(() => re.value.map((t, l) => ({
      ...t,
      color: ae(t.color) || Q.value[l] || O[l] || O[l % O.length]
    })).filter((t) => !y.value.includes(t.id))), G = k(() => H.value.filter((t) => !y.value.includes(t.id)).map((t) => t.value || 0).reduce((t, l) => t + l, 0)), Te = k({
      get() {
        let t = [...Z.value];
        return e.value.style.chart.layout.sorted && (t = [...Z.value].sort((l, o) => o.value - l.value)), t.map((l) => ({
          ...l
        }));
      },
      set(t) {
        return t;
      }
    });
    function Oe(t, l) {
      return t.value / l;
    }
    function Ke(t, l, o) {
      const r = e.value.style.chart.layout.rects.colorRatio - Oe(l, o);
      return He(t, r < 0 ? 0 : r);
    }
    function _e(t, l, o, r) {
      return t.map((m, U) => {
        const le = Ke(ae(l) || Q.value[U] || O[U] || O[U % O.length], m, r), at = Oe(m, r);
        return {
          ...m,
          color: le,
          proportion: at,
          parentName: o,
          children: m.children ? _e(m.children, le, m.name, r) : void 0
        };
      });
    }
    const J = k(() => Dt(
      Te.value.map((t, l) => {
        const o = t.children ? t.children.reduce((r, m) => r + m.value, 0) : t.value;
        return {
          value: t.value,
          id: t.id,
          children: t.children ? _e(t.children.sort((r, m) => m.value - r.value), t.color, t.name, o) : void 0,
          color: t.color,
          name: t.name
        };
      }),
      { x0: B.value.left * 2, y0: B.value.top, x1: B.value.width, y1: B.value.height }
    ));
    function Se({ y0: t, y1: l }) {
      return l - t <= 0 ? 1e-4 : l - t;
    }
    function Ne({ x0: t, x1: l }) {
      return l - t <= 0 ? 1e-4 : l - t;
    }
    function W(t) {
      const l = e.value.style.chart.layout.labels.fontSize * (t.proportion * 2 > 1 ? 1 : t.proportion * 2);
      return l < e.value.style.chart.layout.labels.minFontSize ? e.value.style.chart.layout.labels.minFontSize : l;
    }
    function Qe(t) {
      w.value = t, b.value += 1;
    }
    const q = k(() => ({
      startX: 0,
      startY: 0,
      width: B.value.vbWidth,
      height: B.value.vbHeight
    })), I = f(!1);
    function ue(t, l = H.value) {
      for (const o of l) {
        if (o.id === t)
          return o;
        if (o.children) {
          const r = ue(t, o.children);
          if (r)
            return r;
        }
      }
      return null;
    }
    function et(t) {
      if (I.value)
        d("selectDatapoint", void 0), re.value = H.value;
      else {
        if (d("selectDatapoint", t), !ue(t.parentId))
          return;
        re.value = [ue(t.parentId)];
      }
      I.value = !I.value;
    }
    const L = f(null), Pe = k(() => H.value.map((t, l) => ({
      ...t,
      color: ae(t.color) || Q.value[l] || O[l] || O[l % O.length],
      shape: "square"
    })).sort((t, l) => l.value - t.value).map((t, l) => ({
      ...t,
      proportion: t.value / H.value.map((o) => o.value).reduce((o, r) => o + r, 0),
      opacity: y.value.includes(t.id) ? 0.5 : 1
    }))), tt = k(() => ({
      cy: "treemap-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    }));
    function ze(t) {
      I.value = !1, L.value = null, y.value.includes(t.id) ? y.value = y.value.filter((l) => l !== t.id) : y.value.length < n.dataset.length - 1 && y.value.push(t.id), d("selectLegend", Te.value);
    }
    const ie = f(null);
    function ot({ datapoint: t, seriesIndex: l }) {
      L.value = t, ie.value = { datapoint: t, seriesIndex: l, config: e.value, series: Z.value };
      const o = e.value.style.chart.tooltip.customFormat;
      if (Ee(o) && wt(() => o({
        seriesIndex: l,
        datapoint: t,
        series: Z.value,
        config: e.value
      })))
        N.value = o({
          seriesIndex: l,
          datapoint: t,
          series: Z.value,
          config: e.value
        });
      else {
        let r = "";
        r += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${t.name}</div>`, r += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><rect x="0" y="0" height="12" width="12" stroke="none" fill="${t.color}"/></svg>`, r += `<b>${ne(
          e.value.style.chart.layout.labels.formatter,
          t.value,
          K({
            p: e.value.style.chart.layout.labels.prefix,
            v: t.value,
            s: e.value.style.chart.layout.labels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          { datapoint: t, seriesIndex: l }
        )}</b>`, N.value = `<div>${r}</div>`;
      }
      _.value = !0;
    }
    const R = k(() => {
      const t = J.value.map((o) => ({
        name: o.name,
        color: o.color
      })), l = J.value.map((o) => o.value);
      return { head: t, body: l };
    });
    function Ae() {
      ct(() => {
        const t = R.value.head.map((r, m) => [[
          r.name
        ], [R.value.body[m]], [isNaN(R.value.body[m] / G.value) ? "-" : R.value.body[m] / G.value * 100]]), l = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(t), o = mt(l);
        bt({ csvContent: o, title: e.value.style.chart.title.text || "vue-ui-treemap" });
      });
    }
    const te = k(() => {
      const t = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value,
        e.value.table.columnNames.percentage
      ], l = R.value.head.map((m, U) => {
        const le = ne(
          e.value.style.chart.layout.labels.formatter,
          R.value.body[U],
          K({
            p: e.value.style.chart.layout.labels.prefix,
            v: R.value.body[U],
            s: e.value.style.chart.layout.labels.suffix,
            r: e.value.table.td.roundingValue
          })
        );
        return [
          {
            color: m.color,
            name: m.name,
            shape: "square"
          },
          le,
          isNaN(R.value.body[U] / G.value) ? "-" : K({
            v: R.value.body[U] / G.value * 100,
            s: "%",
            r: e.value.table.td.roundingPercentage
          })
        ];
      }), o = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value
        ],
        head: t,
        body: l,
        config: o
      };
    });
    function lt() {
      return J.value;
    }
    function Fe() {
      F.value.showTable = !F.value.showTable;
    }
    function Ie() {
      F.value.showTooltip = !F.value.showTooltip;
    }
    const oe = f(!1);
    function ce() {
      oe.value = !oe.value;
    }
    return u({
      getData: lt,
      generateCsv: Ae,
      generateImage: $e,
      generatePdf: Ce,
      toggleTable: Fe,
      toggleTooltip: Ie,
      toggleAnnotator: ce
    }), (t, l) => (p(), C("div", {
      ref_key: "treemapChart",
      ref: $,
      class: Re(`vue-ui-treemap ${w.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: D(`font-family:${e.value.style.fontFamily};width:100%; ${e.value.responsive ? "height: 100%;" : ""} text-align:center;background:${e.value.style.chart.backgroundColor}`),
      id: `treemap_${S.value}`,
      onMouseenter: l[3] || (l[3] = () => g(ye)(!0)),
      onMouseleave: l[4] || (l[4] = () => g(ye)(!1))
    }, [
      e.value.userOptions.buttons.annotator ? (p(), E(At, {
        key: 0,
        parent: $.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: oe.value,
        onClose: ce
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : P("", !0),
      Ze.value ? (p(), C("div", {
        key: 1,
        ref_key: "noTitle",
        ref: he,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : P("", !0),
      e.value.style.chart.title.text ? (p(), C("div", {
        key: 2,
        ref_key: "chartTitle",
        ref: M,
        style: D(`width:100%;background:${e.value.style.chart.backgroundColor};padding-bottom:6px`)
      }, [
        (p(), E(kt, {
          key: `title_${fe.value}`,
          config: {
            title: {
              cy: "treemap-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "treemap-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 4)) : P("", !0),
      e.value.userOptions.show && v.value && (g(me) || g(se)) ? (p(), E($t, {
        ref: "details",
        key: `user_option_${b.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: g(we),
        isImaging: g(ke),
        uid: S.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: w.value,
        isTooltip: F.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: $.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: oe.value,
        onToggleFullscreen: Qe,
        onGeneratePdf: g(Ce),
        onGenerateCsv: Ae,
        onGenerateImage: g($e),
        onToggleTable: Fe,
        onToggleTooltip: Ie,
        onToggleAnnotator: ce,
        style: D({
          visibility: g(me) ? g(se) ? "visible" : "hidden" : "visible"
        })
      }, ut({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: T(() => [
            x(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: T(() => [
            x(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: T(() => [
            x(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: T(() => [
            x(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: T(() => [
            x(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: T(({ toggleFullscreen: o, isFullscreen: r }) => [
            x(t.$slots, "optionFullscreen", X(j({ toggleFullscreen: o, isFullscreen: r })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: T(({ toggleAnnotator: o, isAnnotator: r }) => [
            x(t.$slots, "optionAnnotator", X(j({ toggleAnnotator: o, isAnnotator: r })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : P("", !0),
      v.value ? (p(), C("svg", {
        key: 4,
        xmlns: g(yt),
        class: Re({ "vue-data-ui-fullscreen--on": w.value, "vue-data-ui-fulscreen--off": !w.value, "vue-data-ui-zoom-plus": !I.value, "vue-data-ui-zoom-minus": I.value }),
        viewBox: `${q.value.startX} ${q.value.startY} ${q.value.width <= 0 ? 10 : q.value.width} ${q.value.height <= 0 ? 10 : q.value.height}`,
        style: D(`max-width:100%; overflow: hidden; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        De(zt),
        (p(!0), C(Me, null, Ve(J.value, (o, r) => (p(), C("g", null, [
          e.value.style.chart.layout.rects.gradient.show ? (p(), C("defs", Gt, [
            z("radialGradient", {
              id: `tgrad_${o.id}`,
              gradientTransform: "translate(-1, -1.000001) scale(2, 2)"
            }, [
              z("stop", {
                offset: "18%",
                "stop-color": o.color
              }, null, 8, Xt),
              z("stop", {
                offset: "100%",
                "stop-color": g(He)(o.color, e.value.style.chart.layout.rects.gradient.intensity / 100)
              }, null, 8, jt)
            ], 8, qt)
          ])) : P("", !0)
        ]))), 256)),
        (p(!0), C(Me, null, Ve(J.value, (o, r) => (p(), C("g", null, [
          z("rect", {
            x: o.x0,
            y: o.y0,
            height: Se(o),
            width: Ne(o),
            fill: h.value ? o.color : e.value.style.chart.layout.rects.gradient.show ? `url(#tgrad_${o.id})` : o.color,
            rx: e.value.style.chart.layout.rects.borderRadius,
            stroke: L.value && L.value.id === o.id ? e.value.style.chart.layout.rects.selected.stroke : e.value.style.chart.layout.rects.stroke,
            "stroke-width": L.value && L.value.id === o.id ? e.value.style.chart.layout.rects.selected.strokeWidth : e.value.style.chart.layout.rects.strokeWidth,
            onClick: (m) => et(o),
            onMouseenter: () => ot({
              datapoint: o,
              seriesIndex: r
            }),
            onMouseleave: l[0] || (l[0] = (m) => {
              L.value = null, _.value = !1;
            }),
            style: D(`opacity:${L.value ? L.value.id === o.id ? 1 : e.value.style.chart.layout.rects.selected.unselectedOpacity : 1}`),
            class: "vue-ui-treemap-rect"
          }, null, 44, Yt),
          (p(), C("foreignObject", {
            x: o.x0,
            y: o.y0,
            height: Se(o),
            width: Ne(o),
            class: "vue-ui-treemap-cell-foreignObject"
          }, [
            z("div", Jt, [
              e.value.style.chart.layout.labels.showDefaultLabels && (o.proportion > e.value.style.chart.layout.labels.hideUnderProportion || I.value) ? (p(), C("div", {
                key: 0,
                class: "vue-ui-treemap-cell-default",
                style: D(`width:calc(100% - ${W(o) / 1.5}px);text-align:left;line-height:${W(o) < 14 ? 14 : W(o)}px;padding:${W(o) / 3}px; color:${g(We)(o.color)}`)
              }, [
                z("span", {
                  style: D(`width:100%;font-size:${W(o)}px;`)
                }, Y(o.name), 5),
                l[5] || (l[5] = z("br", null, null, -1)),
                z("span", {
                  style: D(`width:100%;font-size:${W(o)}px;`)
                }, Y(g(ne)(
                  e.value.style.chart.layout.labels.formatter,
                  o.value,
                  g(K)({
                    p: e.value.style.chart.layout.labels.prefix,
                    v: o.value,
                    s: e.value.style.chart.layout.labels.suffix,
                    r: e.value.style.chart.layout.labels.rounding
                  }),
                  { datapoint: o }
                )), 5)
              ], 4)) : P("", !0),
              x(t.$slots, "rect", it({ ref_for: !0 }, {
                rect: o,
                shouldShow: o.proportion > e.value.style.chart.layout.labels.hideUnderProportion || I.value,
                fontSize: W(o),
                isZoom: I.value,
                textColor: g(We)(o.color)
              }), void 0, !0)
            ])
          ], 8, Zt))
        ]))), 256)),
        x(t.$slots, "svg", X(j({ svg: B.value, isZoom: I.value, rect: L.value, config: e.value })), void 0, !0)
      ], 14, Et)) : P("", !0),
      t.$slots.watermark ? (p(), C("div", Kt, [
        x(t.$slots, "watermark", X(j({ isPrinting: g(we) || g(ke) })), void 0, !0)
      ])) : P("", !0),
      v.value ? P("", !0) : (p(), E(Ot, {
        key: 6,
        config: {
          type: "treemap",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            treemap: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      z("div", {
        ref_key: "chartLegend",
        ref: A
      }, [
        e.value.style.chart.legend.show ? (p(), E(Tt, {
          key: `legend_${ge.value}`,
          legendSet: Pe.value,
          config: tt.value,
          id: `treemap_legend_${S.value}`,
          onClickMarker: l[1] || (l[1] = ({ legend: o }) => ze(o))
        }, {
          item: T(({ legend: o, index: r }) => [
            z("div", {
              onClick: (m) => ze(o),
              style: D(`opacity:${y.value.includes(o.id) ? 0.5 : 1}`)
            }, [
              Ue(Y(o.name) + ": " + Y(g(ne)(
                e.value.style.chart.layout.labels.formatter,
                o.value,
                g(K)({
                  p: e.value.style.chart.layout.labels.prefix,
                  v: o.value,
                  s: e.value.style.chart.layout.labels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                { datapoint: o }
              )) + " ", 1),
              y.value.includes(o.id) ? (p(), C("span", to, " ( - % ) ")) : (p(), C("span", eo, " (" + Y(isNaN(o.value / G.value) ? "-" : (o.value / G.value * 100).toFixed(e.value.style.chart.legend.roundingPercentage)) + "%) ", 1))
            ], 12, Qt)
          ]),
          _: 1
        }, 8, ["legendSet", "config", "id"])) : x(t.$slots, "legend", {
          key: 1,
          legend: Pe.value
        }, void 0, !0)
      ], 512),
      t.$slots.source ? (p(), C("div", {
        key: 7,
        ref_key: "source",
        ref: ve,
        dir: "auto"
      }, [
        x(t.$slots, "source", {}, void 0, !0)
      ], 512)) : P("", !0),
      De(xt, {
        show: F.value.showTooltip && _.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: $.value,
        content: N.value,
        isFullscreen: w.value,
        isCustom: g(Ee)(e.value.style.chart.tooltip.customFormat)
      }, {
        "tooltip-before": T(() => [
          x(t.$slots, "tooltip-before", X(j({ ...ie.value })), void 0, !0)
        ]),
        "tooltip-after": T(() => [
          x(t.$slots, "tooltip-after", X(j({ ...ie.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isFullscreen", "isCustom"]),
      v.value ? (p(), E(St, {
        key: 8,
        hideDetails: "",
        config: {
          open: F.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: T(() => [
          (p(), E(_t, {
            key: `table_${pe.value}`,
            colNames: te.value.colNames,
            head: te.value.head,
            body: te.value.body,
            config: te.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: l[2] || (l[2] = (o) => F.value.showTable = !1)
          }, {
            th: T(({ th: o }) => [
              z("div", {
                innerHTML: o,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, oo)
            ]),
            td: T(({ td: o }) => [
              Ue(Y(o.name || o), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : P("", !0)
    ], 46, Wt));
  }
}, wo = /* @__PURE__ */ It(lo, [["__scopeId", "data-v-f3bac1ee"]]);
export {
  wo as default
};
